<?php

namespace App\Console;

use App\Console\Commands\Apollo;
use App\Console\Commands\BehaviorRecord;
use App\Console\Commands\CalcPostWeight;
use App\Console\Commands\ContentFeedCreate;
use Illuminate\Console\Scheduling\Schedule;
use Laravel\Lumen\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        Apollo::class,
        BehaviorRecord::class,
        CalcPostWeight::class,
        ContentFeedCreate::class
    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
        $path = storage_path('logs/'.date('Y-m-d').'-schedule.log');
        $schedule->command('post:calc_weight')
            ->everyFifteenMinutes()->withoutOverlapping()->appendOutputTo($path);
    }
}
